<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;

class GoodsRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return false;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
            'id' => ['sometimes', 'required', 'integer', 'exists:goods,id'],
            'title' => ['required', 'string', 'max:191'],
            'img_url' => ['string', 'max:191'],
            'type_id' => ['required', 'integer', 'exists:goods_types,id'],
            'brand_id' => ['integer', 'exists:goods_brands,id'],
            'goods_code' => ['required', 'alpha_dash', 'max:32', Rule::unique('goods')->ignore(request('goods_id'))],
        ];
    }

    public function arrayRules($arrayName)
    {
        $arrayRules = [];
        $rules = $this->rules();
        foreach ($rules as $key => $val) {
            $arrayRules[$arrayName . $key] = $val;
        }

        return $arrayRules;
    }
}
